/*
 * Isac.java
 * gadei
 */

package isac.jedit


// {{{ imports

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.gjt.sp.jedit.EBComponent;
import org.gjt.sp.jedit.EBMessage;
import org.gjt.sp.jedit.EditBus;
import org.gjt.sp.jedit.GUIUtilities;
import org.gjt.sp.jedit.View;
import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.jedit.gui.DefaultFocusComponent;
import org.gjt.sp.jedit.gui.DockableWindowManager;
import org.gjt.sp.jedit.msg.PropertiesChanged;
import org.gjt.sp.util.Log;
import org.gjt.sp.util.StandardUtilities;
// }}}

// {{{ Isac class
/**
 * 
 * Isac - a dockable JPanel, a demonstration of a jEdit plugin.
 *
 */

object Isac {
  def getFilename(): String ={
            val str = "filename": String
            str
    }

}

class Isac(view: View, position: String) extends JPanel(new BorderLayout)
{
    private final val serialVersionUID = 6412255692894321789L

    var filename = "IsacTestFile.txt"

    var defaultFilename = "IsacTestFile.txt"

    var floating= position.equals(DockableWindowManager.FLOATING): Boolean

    var toolPanel = new IsacToolPanel(this)

    if (jEdit.getSettingsDirectory() != null) {
      filename = jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "filepath")

            if (this.filename == null || this.filename.length() == 0) {
                    this.filename = new String(jEdit.getSettingsDirectory()
                                    + File.separator + "qn.txt")

                    jEdit.setProperty(
                                    IsacPlugin.OPTION_PREFIX + "filepath",
                                    this.filename)

            }
            this.defaultFilename = this.filename
    }
    
    add(BorderLayout.NORTH, this.toolPanel)

    if (floating)
            this.setPreferredSize(new Dimension(500, 250))

    var textArea = new IsacTextArea()
    textArea.setFont(IsacOptionPane.makeFont())

    val pane = new JScrollPane(textArea)
    add(BorderLayout.CENTER, pane)

    this.readFile()
	

// {{{ Member Functions

// {{{ focusOnDefaultComponent
    def focusOnDefaultComponent() {
            textArea.requestFocus()
    }
// }}}

// {{{ getFileName
    def getFilename(): String ={
            val str = "filename": String
            str
    }
// }}}

    // EBComponent implementation

// {{{ handleMessage
    def handleMessage(message: EBMessage) {
      if (message.isInstanceOf[PropertiesChanged]) {
                    propertiesChanged();
            }
    }
// }}}

// {{{ propertiesChanged
    private def propertiesChanged() {
            val propertyFilename = jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "filepath");
            if (!StandardUtilities.objectsEqual(defaultFilename, propertyFilename)) {
                    saveFile()
                    toolPanel.propertiesChanged()
                    defaultFilename = propertyFilename
                    filename = defaultFilename
                    readFile()
            }
            val newFont = IsacOptionPane.makeFont(): Font
            if (!newFont.equals(textArea.getFont())) {
                    textArea.setFont(newFont);
            }
    }
// }}}

    // These JComponent methods provide the appropriate points
    // to subscribe and unsubscribe this object to the EditBus.

// {{{ addNotify
    override def addNotify() {
            super.addNotify()
            EditBus.addToBus(this)
    }
 // }}}

  def saveFile() {
            if (filename == null || filename.length() == 0) {

            }
            else
          {
              val out = new FileWriter(filename)
              out.write(textArea.getText())
              out.close()
            }
    }

// {{{ removeNotify
    override def removeNotify() {
            saveFile()
            super.removeNotify()
            EditBus.removeFromBus(this)
    }
// }}}


// {{{ chooseFile
    def chooseFile() {
            val paths = GUIUtilities.showVFSFileDialog(view, null,
                            JFileChooser.OPEN_DIALOG, false);
            if (paths != null && !paths(0).equals(filename)) {
                    saveFile();
                    filename = paths(0);
                    toolPanel.propertiesChanged();
                    readFile();
            }
	}
    // }}}

    // {{{ copyToBuffer
	def copyToBuffer() {
		jEdit.newFile(view)
		//GAdei Test view.getEditPane().getTextArea().setText(textArea.getText());
                view.getEditPane().getTextArea().setText("New Project: Gadei the king! BIIIIIG LOOOOOOOOL")
	}
    // }}}
    // {{{ readFile()
	/**
	 * Helper method
	 */
	def readFile() {
		if (filename == null || filename.length() == 0)
                {

                }
                else
                {
                  var bf = new BufferedReader(new FileReader(filename))
                  val sb = new StringBuffer(2048)
                  var str="": String
                  if (bf != null) {
                    /*
                    while ((str = bf.readLine()) != "") {
                      System.out.println("Mein Stŕing aus Isac.scala:" + str)
                            sb.append(str).append('\n')
                    } */

                    bf.close()
                    textArea.setText(sb.toString())
                  }
                }
    /*  TEST */ /* --------------------------------------------------*/
    /*
    if (filename == null || filename.length() == 0)
			return;

		BufferedReader bf = null;
		try {
			bf = new BufferedReader(new FileReader(filename));
			StringBuffer sb = new StringBuffer(2048);
			String str;
			while ((str = bf.readLine()) != null) {
				sb.append(str).append('\n');
			}
			bf.close();
			textArea.setText(sb.toString());
		} catch (FileNotFoundException fnf) {
			Log.log(Log.ERROR, QuickNotepad.class, "notepad file " + filename
					+ " does not exist");
		} catch (IOException ioe) {
			Log.log(Log.ERROR, QuickNotepad.class,
					"could not read notepad file " + filename);
		}

    */

    /*  TEST */ /* --------------------------------------------------*/

		
	}

}
// }}}
